"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const exec_1 = __importDefault(require("@simplyhexagonal/exec"));
const commander_1 = require("commander");
const fs_1 = __importDefault(require("fs"));
main();
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        commander_1.program
            .name('npm-publish')
            .description('Publish a package to npm')
            .addHelpText('after', `
   
   Before publishing deep.json version syncronizes with package.json version. Package will not be published if there are newer version in npm`);
        commander_1.program
            .option('--new-version <new_version>', 'New version to publish')
            .option('--package-json-file-path <package_json_file_path>', 'package.json file path')
            .option('--deep-json-file-path <deep_json_file_path>', 'deep.json file path');
        commander_1.program.parse(process.argv);
        const { newVersion = 'patch', packageJsonPath = path_1.default.resolve('package.json'), deepJsonFilePath = path_1.default.resolve('deep.json'), } = commander_1.program.opts();
        const packageJson = yield Promise.resolve(`${packageJsonPath}`).then(s => __importStar(require(s)));
        const { execPromise } = (0, exec_1.default)(`npm view ${packageJson.name} version`);
        const execResult = yield execPromise;
        if (execResult.exitCode !== 0) {
            throw new Error(execResult.stderrOutput.trim());
        }
        const npmLatestPackageJsonVersion = execResult.stdoutOutput.toString().trim();
        const packageJsonVersion = packageJson.version;
        if (npmLatestPackageJsonVersion > packageJsonVersion) {
            throw new Error(`Version ${packageJson.version} in ${packageJsonPath} is outdated. Latest version in npm is ${npmLatestPackageJsonVersion}. Execute npm-pull`);
        }
        if (npmLatestPackageJsonVersion === packageJsonVersion) {
            yield execWrapped({
                command: `npm version --allow-same-version ${newVersion}`,
            });
            yield updateDeepJsonVersion({
                version: newVersion,
                filePath: deepJsonFilePath,
            });
        }
        if (npmLatestPackageJsonVersion < packageJsonVersion) {
            yield execWrapped({ command: `npm version ${packageJsonVersion}` });
            yield updateDeepJsonVersion({
                version: newVersion,
                filePath: deepJsonFilePath,
            });
        }
    });
}
function updateDeepJsonVersion({ version, filePath, }) {
    return __awaiter(this, void 0, void 0, function* () {
        const deepPackage = yield Promise.resolve(`${filePath}`).then(s => __importStar(require(s)));
        deepPackage.package.version = version;
        fs_1.default.writeFileSync(filePath, JSON.stringify(deepPackage, null, 2), 'utf-8');
    });
}
function execWrapped({ command }) {
    return __awaiter(this, void 0, void 0, function* () {
        const { execPromise, execProcess } = (0, exec_1.default)(command);
        const execResult = yield execPromise;
        if (execResult.exitCode !== 0) {
            throw new Error(execResult.stderrOutput);
        }
        console.log(execResult.stdoutOutput);
        return { execProcess, execPromise, execResult };
    });
}
